



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java基础——对象容器（顺序、集合、Hash）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java基础——对象容器（顺序、集合、Hash）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 13:49:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2><strong>扩展：</strong></h2>
<p>For-each循环</p>
<p>for (String s: str) {<br />	System.out.println(s);</p>
<p>}</p>
<p>等同于<br />for (int i = 0; i &lt; str.length; i++) {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;String s = str[i];<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System.out.println(s);<br />}</p>
<p>是J2SE 1.5提供的另一种形式的<a href="https://www.baidu.com/s?wd=for%E5%BE%AA%E7%8E%AF&amp;tn=44039180_cpr&amp;fenlei=mv6quAkxTZn0IZRqIHckPjm4nH00T1YdnyfvuWfLnHNhP1nznAwW0ZwV5Hcvrjm3rH6sPfKWUMw85HfYnjn4nH6sgvPsT6KdThsqpZwYTjCEQLGCpyw9Uz4Bmy-bIi4WUvYETgN-TLwGUv3EnWbYPHfvn1b1" rel="external nofollow noreferrer">for循环</a>,可以用来处理不知道str长度的情况</p>
<h2><strong>顺序容器</strong></h2>
<p>泛型容器类 ArrayList</p>
<p>ArrayList&lt;String&gt; notes = new ArrayList&lt;String&gt;</p>
<p>容器的类型ArrayList &nbsp;元素的类型String</p>
<p>例子：</p>
<p><strong>package</strong>&nbsp;notes;</p>
<p><strong>import</strong>&nbsp;java.util.ArrayList;</p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;NotesBook {</p>
<p><strong>private</strong>&nbsp;ArrayList&lt;String&gt; notes&nbsp;= <strong>new</strong>&nbsp;ArrayList&lt;String&gt;();		//创建容器：notes</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;add(String s){ 										//添加方法</p>
<p>notes.add(s);</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;add(String s, <strong>int</strong>&nbsp;Location){</p>
<p>notes.add(Location, s);</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>int</strong>&nbsp;getSize(){											//获取数量</p>
<p><strong>return</strong>&nbsp;notes.size();</p>
<p>}</p>
<p><strong>public</strong>&nbsp;String getNote(<strong>int</strong>&nbsp;index){								//通过索引来查找</p>
<p><strong>return</strong>&nbsp;notes.get(index);</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;removeNote(<strong>int</strong>&nbsp;index){								//通过索引删除</p>
<p>notes.remove(index) ;</p>
<p>}</p>
<p><strong>public</strong>&nbsp;String[] list(){</p>
<p>String[] a&nbsp;= <strong>new</strong>&nbsp;String[notes.size()];						//获取一个实际的数组（包含了列表的内容）</p>
<p>//		for( int&nbsp;i=0;i&lt;notes.size();i++){</p>
<p>//			a[i]=notes.get(i);</p>
<p>//		}</p>
<p>notes.toArray(a);				//相当于以上循环</p>
<p><strong>return</strong>&nbsp;a;</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>static</strong>&nbsp;<strong>void</strong>&nbsp;main(String[] args) {</p>
<p>NotesBook nb&nbsp;= <strong>new</strong>&nbsp;NotesBook();</p>
<p>nb.add("first");</p>
<p>nb.add("second");</p>
<p>nb.add("thrid", 1);</p>
<p>System.<strong><em>out</em></strong>.println(nb.getSize());</p>
<p>System.<strong><em>out</em></strong>.println(nb.getNote(1));</p>
<p>System.<strong><em>out</em></strong>.println("remove后-------------------------");</p>
<p>nb.removeNote(1);</p>
<p>String[] a&nbsp;=nb.list();</p>
<p><strong>for</strong>(String s&nbsp;: a){								//处理不知道s长度的情况</p>
<p>System.<strong><em>out</em></strong>.println(s);</p>
<p>}</p>
<p>}</p>
<p>}</p>
<h2><strong>对象数组</strong></h2>
<p>对象数组中的每个元素都是对象的管理者而非对象本身。</p>
<p>For-each循环</p>
<p><strong>class</strong>&nbsp;Value{</p>
<p><strong>private</strong>&nbsp;<strong>int</strong>&nbsp;i;</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;set(<strong>int</strong>&nbsp;i){</p>
<p><strong>this</strong>.i=i;</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>int</strong>&nbsp;get(){</p>
<p><strong>return</strong>&nbsp;i;</p>
<p>}</p>
<p>}</p>
<p>....</p>
<p><strong>public</strong>&nbsp;<strong>static</strong>&nbsp;<strong>void</strong>&nbsp;main(String[] args) {</p>
<p>Value[] a&nbsp;= <strong>new</strong>&nbsp;Value[10];</p>
<p><strong>for</strong>( <strong>int</strong>&nbsp;i=0; i&lt;a.length; i++){</p>
<p>a[i] = <strong>new</strong>&nbsp;Value();</p>
<p>a[i].set(i);</p>
<p>}</p>
<p><strong>for</strong>(Value v&nbsp;: a){</p>
<p>System.<strong><em>out</em></strong>.println(v.get());</p>
<p>v.set(0);				//在此设置为0</p>
<p>}</p>
<p><strong>for</strong>(Value v&nbsp;: a){</p>
<p>System.<strong><em>out</em></strong>.println(v.get());</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p><strong>容器类也是可以使用for-each</strong></p>
<p>ArrayList&lt;String&gt; b&nbsp;= <strong>new</strong>&nbsp;ArrayList&lt;String&gt;();</p>
<p>b.add("first");</p>
<p>b.add("second");</p>
<p><strong>for</strong>&nbsp;(String s&nbsp;: b){</p>
<p>System.<strong><em>out</em></strong>.println(s);</p>
<p>}</p>
<p><strong>集合容器（set） 就是数学上的集合set（唯一性 没有排序）</strong></p>
<p><strong>格式：</strong>HashSet&lt;String&gt; s&nbsp;= <strong>new</strong>&nbsp;HashSet&lt;String&gt;();</p>
<p>区别：</p>
<p>ArrayList&lt;String&gt; b&nbsp;= <strong>new</strong>&nbsp;ArrayList&lt;String&gt;();</p>
<p>b.add("first");</p>
<p>b.add("second");</p>
<p>b.add("first");</p>
<p><strong>for</strong>&nbsp;(String s&nbsp;: b){</p>
<p>System.<strong><em>out</em></strong>.println(s);</p>
<p>}</p>
<p>System.<strong><em>out</em></strong>.println("------我是分割线------");</p>
<p>HashSet&lt;String&gt; s&nbsp;= <strong>new</strong>&nbsp;HashSet&lt;String&gt;();</p>
<p>s.add("F1");</p>
<p>s.add("S2");</p>
<p>s.add("F1");</p>
<p><strong>for</strong>(String k&nbsp;: s){</p>
<p>System.<strong><em>out</em></strong>.println(k);</p>
<p>}</p>
<p>更加直观的直接输出s 结果如下：</p>
<p>而这两个容器包括了普通如上value类中加了（public String toString（）{return &ldquo;&rdquo;+i}）</p>
<p><strong>Hash表 也叫做散列表HashMap&lt;k,v&gt; 键是唯一的输出最后一个</strong></p>
<p>Java的Hash表可以以任何实现了hash()函数的类的对象做值来存放对象。</p>
<p><strong>private</strong>&nbsp;HashMap&lt;Integer,String&gt; cname&nbsp;= <strong>new</strong>&nbsp;HashMap&lt;Integer,String&gt;();</p>
<p><strong>package</strong>&nbsp;notes;</p>
<p><strong>import</strong>&nbsp;java.util.HashMap;</p>
<p><strong>import</strong>&nbsp;java.util.Scanner;</p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;Corn {</p>
<p><strong>private</strong>&nbsp;HashMap&lt;Integer,String&gt; cname&nbsp;= <strong>new</strong>&nbsp;HashMap&lt;Integer,String&gt;();</p>
<p><strong>public</strong>&nbsp;Corn(){								//构造</p>
<p>cname.put(1, "penny");</p>
<p>cname.put(10, "dime");</p>
<p>cname.put(25, "quarter");</p>
<p>cname.put(50, "half-dolar");</p>
<p>System.<strong><em>out</em></strong>.println(cname.keySet().size());</p>
<p><strong>for</strong>(Integer k: cname.keySet()){</p>
<p>String s&nbsp;=cname.get(k);</p>
<p>System.<strong><em>out</em></strong>.println(s);</p>
<p>}</p>
<p>}</p>
<p><strong>public</strong>&nbsp;String getName( <strong>int</strong>&nbsp;amount){</p>
<p><strong>if</strong>(cname.containsKey(amount)){</p>
<p><strong>return</strong>&nbsp;cname.get(amount);</p>
<p>}<strong>else</strong>{</p>
<p><strong>return</strong>&nbsp;"NOT FOUND";</p>
<p>}</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>static</strong>&nbsp;<strong>void</strong>&nbsp;main(String[] args) {</p>
<p>Scanner in&nbsp;= <strong>new</strong>&nbsp;Scanner(System.<strong><em>in</em></strong>);</p>
<p><strong>int</strong>&nbsp;amount&nbsp;=in.nextInt();</p>
<p>Corn corn&nbsp;=<strong>new</strong>&nbsp;Corn();</p>
<p>String name= corn.getName(amount);</p>
<p>System.<strong><em>out</em></strong>.println(name);</p>
<p>}</p>
<p>}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8od5z1q.html">HDU 3333 &vert; Codeforces 703D 树状数组、离散化</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqln15k8.html">利用jQuery对插件进行扩展时，方法&dollar;&period;extend&lpar;&rpar;、&dollar;&period;fn&period;extend&lpar;&rpar;区别与联系</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxoordq.html">Log4Net组件的应用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn0v0x9.html">canvas判断边距，反弹和拖拽的综合实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p1lvk9.html">RouteOS软路由HotSpot热点认证网关添加白名单和黑名单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew25z9.html">&lpar;转&rpar;Log4net 配置类库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjvo5d9.html">mysql alter的常用用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmdlzq.html">centos6&period;5安装gcc6&period;1等c&plus;&plus;环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde43kj9.html">poj 3735   大数量反复操作问题（矩阵高速幂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8med6prq.html">图像操作相关 With Quartz 2D</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zlgpx9.html">X-008 FriendlyARM tiny4412 uboot移植之copy u-boot到DDR内存</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz27eg8.html">Java数据库连接错误集</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwe4r8.html">第五章之S5PV210将u-boot&period;bin从SD卡中搬到DDR中</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyv6mjq.html">Linux-Centos7系统下安装python2并与python3版本共存</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvm3zr8.html">UFS 介绍 1&lbrack;【转】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2ge6o9.html">什么是编程语言，什么是Python解释器</a>
		</li>
						<li><a href="https://www.batexi.com/a/96067p39.html">OpenKM6&period;2&period;5的安装和配置详细过程（附启动失败原因）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmzoll9.html">Spring（十六）：泛型依赖注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjkmpjq.html">ls命令显示的total你知道代表着什么吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjx2308.html">洛谷P4902乘积</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gjpye79.html">UVA1616-Caravan Robbers&lpar;二分&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1050q.html">C&plus;&plus; 入门&lbrack;1&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2em0o9.html">第8章 java中的并发工具类</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd235d9.html">&lbrack;ASP&period;NET&rsqb;ScriptManager控件使用  转载</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1moow9.html">禁止 gVim 在 Linux 下自动生成 undo 文件 &ast;&period;un~</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g3eovq.html">automake - 使用 autotools 工具集</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvl3z38.html">Linux并发与同步专题 &lpar;4&rpar; Mutex互斥量</a>
			</li>
						<li><a href="https://www.batexi.com/a/qll1636q.html">Generative Adversarial Nets&lbrack;AAE&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd2pl09.html">Python学习总结 10 自动化测试Selenium2</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ko3vq.html">Android so注入&lpar;inject&rpar;和Hook技术学习（一）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
